VERSION 5.00
Begin VB.Form frmControl 
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   720
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1170
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   720
   ScaleWidth      =   1170
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Caption         =   "End"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**********************************************************************************
' Borderless Form Move & Resize routines.
' Using a minimal set of Windows API.
'**********************************************************************************
' Made by Yves Geltmeyer (yge@blubay.com) on January 2004
'**********************************************************************************
' Please, use this code freely even for commercial use.
'
' NOTE
' ----
' Remove the menu (used only for sample purpose) to remove the form black border
'**********************************************************************************

Option Explicit

' Windows structure and API declarations
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

' Local constants and variables declarations
Const BorderPixels = 5
Private TwipX As Single, TwipY As Single, BorderWidth As Single, BorderHeight As Single

Private WithEvents m_cHotKey  As cRegHotKey
Attribute m_cHotKey.VB_VarHelpID = -1

Private Sub Command1_Click()
    Call showTaskBar
    Set m_cHotKey = Nothing
    End
End Sub

Private Sub Form_Load()
    ' TwipX and TwipY used only for easier writing
    TwipX = Screen.TwipsPerPixelX
    TwipY = Screen.TwipsPerPixelY
    
    ' Following variables used to speed-up the process (prevent recalc of BorderPixels * ...)
    BorderWidth = BorderPixels * TwipX
    BorderHeight = BorderPixels * TwipY
    
    frmMain.Show vbModeless
    
    ' Register hotkey
    Set m_cHotKey = New cRegHotKey
    m_cHotKey.Attach Me.hwnd
    m_cHotKey.RegisterKey "Activate", vbKeyF2, MOD_ALT
    gbolIsRunning = True
    Me.Hide
    
End Sub

Private Sub Form_Terminate()
    Call showTaskBar
    Set m_cHotKey = Nothing
    End
End Sub

Private Sub m_cHotKey_HotKeyPress(ByVal sName As String, ByVal eModifiers As EHKModifiers, ByVal eKey As KeyCodeConstants)
    m_cHotKey.RestoreAndActivate Me.hwnd
    
    gbolIsRunning = Not gbolIsRunning
    If gbolIsRunning Then
        frmControl.Hide
        frmMain.Show vbModeless
    Else
        frmControl.Show vbModeless
        frmMain.Hide
    End If
End Sub


Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim RLeft As Single, RTop As Single, RRight As Boolean, RBottom As Boolean
    Dim StartX As Single, StartY As Single, MX As Single, MY As Single
        
    If Button And vbLeftButton Then
        ' Read the mouse pointer screen position on the beginning
        GetMouseXY StartX, StartY
        ' We don't use the X,Y arguments which are incorect when MouseDown event called
        ' from other screen objects (like Label1 and Image1 hereunder)
        X = StartX - Left
        Y = StartY - Top
        
        ' Flags indicating "from where" the form is being resized
        RLeft = IIf(X < BorderWidth, Width, 0)
        RTop = IIf(Y < BorderHeight, Height, 0)
        RRight = (X > Width - BorderWidth)
        RBottom = (Y > Height - BorderHeight)
        
        ' Place the mouse pointer on the form border for more accuracy
        If RLeft Then SetMouseXY Left, Top + Y
        If RTop Then SetMouseXY Left + X, Top
        If RRight Then SetMouseXY Left + Width, Top + Y
        If RBottom Then SetMouseXY Left + X, Top + Height
        
        ' Save the mouse pointer screen position on the beginning in variables
        GetMouseXY StartX, StartY
        ' While left mouse button is pressed
        While GetAsyncKeyState(vbLeftButton) < 0
            ' Read the actual mouse pointer screen position
            GetMouseXY MX, MY
            
            If RRight Or RLeft Or RBottom Or RTop Then      ' If the form is resized (not moved)
                If RLeft And RLeft + StartX - MX > BorderWidth * 2 Then Move MX, Top, RLeft + StartX - MX
                If RTop And RTop + StartY - MY > BorderHeight * 2 Then Move Left, MY, Width, RTop + StartY - MY
                If RRight And MX - Left > BorderWidth * 2 Then Width = MX - Left
                If RBottom And MY - Top > BorderHeight * 2 Then Height = MY - Top
            Else                                            ' If the form is moved (not resized)
                MousePointer = vbSizeAll                    ' Sets the mouse cursor showing move
                Move MX - X, MY - Y                         ' Actually moves the form on screen
            End If
            DoEvents                                        ' To allow Windows painting events
        Wend
    ElseIf Button And vbRightButton Then
        'PopupMenu mnuMenu
    End If
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Reset the mouse cursor when left mouse button is not pressed
    If GetAsyncKeyState(vbLeftButton) >= 0 Then MousePointer = 0
    ' Set the correct mouse cursor according to its position on the form
    If X > Width - BorderWidth Or X < BorderWidth Then MousePointer = vbSizeWE
    If Y > Height - BorderHeight Or Y < BorderHeight Then MousePointer = vbSizeNS
    If (X > Width - BorderWidth And Y > Height - BorderHeight) Or (X < BorderWidth And Y < BorderHeight) Then MousePointer = vbSizeNWSE
    If (X > Width - BorderWidth And Y < BorderHeight) Or (X < BorderWidth And Y > Height - BorderHeight) Then MousePointer = vbSizeNESW
End Sub

' Reads actual mouse pointer screen position and convert it to TWIP scale
Private Sub GetMouseXY(X As Single, Y As Single)
    Dim lpPoint As POINTAPI

    GetCursorPos lpPoint
    X = lpPoint.X * TwipX
    Y = lpPoint.Y * TwipY
End Sub

' Places mouse pointer on given screen position given in TWIP scale
Private Sub SetMouseXY(ByVal X As Single, ByVal Y As Single)
    SetCursorPos X / TwipX, Y / TwipY
End Sub

Private Sub Label1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Form_MouseDown Button, Shift, X, Y      ' Send the event to underlying form
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Form_MouseDown Button, Shift, X, Y      ' Send the event to underlying form
End Sub

Private Sub mnuExit_Click()
    End
End Sub

